# -*- coding: utf-8 -*-
"""
Opérations simples sur les matrices : calcul de rang, d'inverse...

"""

import pivot_gauss
from copy import deepcopy


def rang(A):
    """
    Calcule le rang de A et le retourne
    """
    C = deepcopy(A) # on travaille maintenant avec C pour éviter de modifier A


def identite(n):
    """
    Cré la matrice identité de taille n et la retourne
    """
    In = []

    return In


def inverse(A):
    """
    Retourne l'inverse de A
    """
    if (len(A) != len(A[0])):
        print('Matrice non carrée')
        return
    C = deepcopy(A)


def solutions(A, B):
    """
    Retourne les solutions de AX = B.

    S'il n'y a pas de solutions, retourne None
    S'il y a une unique solution, retourne la matrice colonne correspondante.
    S'il y a une infinité de solution, retourne [X_p, [C1, ..., Cp]] où Xp est une solution
    et Vect(C1, ..., Cp) est l'ensemble des solutions du système homogène.
    """
    return
