# -*- coding: utf-8 -*-

#####################################################################################################
### Matrices A et B caractéristiques du système de 21 équations à 21 inconnues #####
#####################################################################################################

A=[[1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0], [0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0], [0.0, 0.0, 1.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0], [0.0, 0.0, 0.0, 1.0, 0.0, 16.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0], [0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0], [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0], [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0], [0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0], [0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0], [0.0, 0.0, -1.5, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, -3.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0], [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 3.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0], [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0], [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0], [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0], [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0], [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 0.0], [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 0.0], [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0, 0.0], [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0, 0.0], [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0], [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0]]
B=[[0.0], [0.0], [245250.0], [2943000.0], [-147150.0], [0.0], [0.0], [0.0], [0.0], [147150.0], [0.0], [0.0], [36787.5], [331087.5], [147150.0], [0.0], [0.0], [0.0], [-183937.5], [0.0], [0.0]]

#####################################################################################################
### Algorithme du pivot de Gauss #####
#####################################################################################################


def echange(A, i, j):
    """
    A est une matrice

    Echange les lignes i et j dans A.
    """
    temp = A[i]
    A[i] = A[j]
    A[j] = temp


def multiplie(A, i, k):
    """
    Multiplie la ligne i de la matrice A par une constante k non nulle.
    """
    if k == 0:
        return A
    A[i] = k * A[i]


def combinaison(A, i, j, k):
    """
    Ajoute k fois la ligne j à la ligne i dans A.
    i doit être différent de j
    """
    return


def cherche_pivot_colonne(A, j, ligne_min):
    """
    Trouve un pivot dans la colonne j de A en dessous (<=) de ligne_min.

    Retourne l'indice de la ligne trouvée ou Nonee si tous les coefficients de
    la colonne sont nuls.
    """
    return None


def echelonne(A, B=None):
    """
    Echelonne la matrice A par l'algorithme du pivot de Gauss.
    Reporte les opérations sur la matrice B si une matrice est donnée.
    """
    l, c = 0, 0  # ligne et colonne courante
    while (l < len(A) and c < len(A[0])):
        p = cherche_pivot_colonne(A, c, l)
        if p is not None:  # sinon tous les coefficients de cette colonne sont nuls
            if p != l:
                # échange dans A
                if B is not None:
                    # échange dans B
            # et c'est parti pour les combinaisons.


    return A, B


def cherche_pivot_ligne(A, i):
    """
    Trouve l'indice du premier coefficient non nul dans la ligne i de la matrice A

    Retourne cet indice ou None si la ligne est nulle.
    """
    return None


def reduit(A, B=None):
    """
    Reduit la matrice échelonnée A et reporte les opération sur B.
    """
    l = len(A) - 1
    while l > 0:
        c = cherche_pivot_ligne(A, l)
        if c is not None:
            # on a trouvé un pivot !


    return A, B


##### Test
#
#A1 = [[1,2,3],[3,1,2],[2,3,1]]
#
#print(A1)
#echange(A1, 0, 1)
#print(A1)
#multiplie(A1, 1, 10)
#print(A1)
#combinaison(A1, 1, 2, 100)
#print(A1)
#print(cherche_pivot_colonne(A1, 1, 0))
#print(echelonne(A1))
#print(A1)
